## dolphin-emu 2509%2Bdfsg

=== CMakeLists.txt ===
########################################
# General setup
#
cmake_minimum_required(VERSION 3.13)

cmake_policy(SET CMP0079 NEW) # let target_link_libraries() link to a target defined in a different directory
cmake_policy(SET CMP0080 OLD) # allow using BundleUtilities at configure time

if (POLICY CMP0099)
  cmake_policy(SET CMP0099 NEW) # Propagate INTERFACE_LINK_OPTIONS from private dependencies, used by MacOS framework builds of SDL
endif()

# Weird chicken-and-egg problem: We can't check the compiler before the project() call, but we have to set the policies before it.
# So we do this in two steps: Set the policies if they exist, then error out afterwards if we end up being MSVC and they don't exist.
if (POLICY CMP0117)
  cmake_policy(SET CMP0091 NEW) # MSVC runtime library flags are selected by an abstraction.
  cmake_policy(SET CMP0092 NEW) # MSVC warning flags are not in CMAKE_{C,CXX}_FLAGS by default.
  cmake_policy(SET CMP0117 NEW) # MSVC RTTI flag will not be added by default.
endif()

if (POLICY CMP0141)
  cmake_policy(SET CMP0141 NEW) # MSVC debug information format flags are selected by an abstraction.
endif()

# Minimum OS X version.
# This is inserted into the Info.plist as well.
set(CMAKE_OSX_DEPLOYMENT_TARGET "11.0.0" CACHE STRING "")

set(CMAKE_USER_MAKE_RULES_OVERRIDE "${CMAKE_CURRENT_SOURCE_DIR}/CMake/FlagsOverride.cmake")

project(dolphin-emu)

if (MSVC)
  if (POLICY CMP0117)
    # cmake is a weird language. You can't do if(not POLICY)
  else()
    message(FATAL_ERROR "Please update to CMake 3.20 or higher.")
  endif()

  set(CMAKE_C_STANDARD 99)
  set(CMAKE_CXX_STANDARD 23)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

set(COMPILER ${CMAKE_CXX_COMPILER_ID})
if (COMPILER STREQUAL "GNU")
  set(COMPILER "GCC") # prefer printing GCC instead of GNU
endif()

# Enforce minimum compiler versions that support the c++20 features we use
set (GCC_min_version 11)
set (Clang_min_version 14)
set (AppleClang_min_version 14.0.3)
set (min_xcode_version "14.0") # corresponding xcode version for AppleClang_min_version
set (MSVC_min_version 14.32)
set (min_vs_version "2022 17.2.3") # corresponding Visual Studio version for MSVC_min_version

message(STATUS "Using ${COMPILER} ${CMAKE_CXX_COMPILER_VERSION}")

if ("-" STREQUAL "${${COMPILER}_min_version}-")
  message(WARNING "Unknown compiler ${COMPILER}, assuming it is new enough")
else()
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS  ${${COMPILER}_min_version})
    message(FATAL_ERROR "Requires GCC ${GCC_min_version}, Clang ${Clang_min_version},"
    " AppleClang ${AppleClang_min_version} (Xcode ${min_xcode_version}),"
    " or MSVC ${MSVC_min_version} (Visual Studio ${min_vs_version}) or higher")
  endif()
endif()

# Name of the Dolphin distributor. If you redistribute Dolphin builds (forks,
# unofficial builds) please consider identifying your distribution with a
# unique name here.
set(DISTRIBUTOR "None" CACHE STRING "Name of the distributor.")

set(DOLPHIN_DEFAULT_UPDATE_TRACK "" CACHE STRING "Name of the default update track. If empty, disables auto-update.")

if(UNIX AND NOT APPLE AND NOT ANDROID)
  option(ENABLE_X11 "Enables X11 Support" ON)
endif()
if(NOT WIN32 AND NOT APPLE AND NOT HAIKU)
  option(ENABLE_EGL "Enables EGL OpenGL Interface" ON)
endif()

if(NOT ANDROID)
  option(ENABLE_CLI_TOOL "Enable dolphin-tool, a CLI-based utility for functions such as managing disc images" ON)
endif()


set(USE_SYSTEM_LIBS "AUTO" CACHE STRING "Use system libraries instead of bundled libraries.  ON - Always use system and fail if unavailable, OFF - Always use bundled, AUTO - Use system if available, otherwise use bundled.  Default is AUTO")
if(APPROVED_VENDORED_DEPENDENCIES)
  message(WARNING "APPROVED_VENDORED_DEPENDENCIES is deprecated.  Please migrate to setting USE_SYSTEM_LIBS to ON and setting USE_SYSTEM_<dependency> to either AUTO or OFF to allow bundled libs.")
endif()
option(USE_UPNP "Enables UPnP port mapping support" ON)
option(ENABLE_NOGUI "Enable NoGUI frontend" ON)
option(ENABLE_QT "Enable Qt (Default)" ON)
option(ENABLE_LTO "Enables Link Time Optimization" OFF)
option(ENABLE_GENERIC "Enables generic build that should run on any little-endian host" OFF)
option(ENABLE_HEADLESS "Enables running Dolphin as a headless variant" OFF)
option(ENABLE_ALSA "Enables ALSA sound backend" ON)
option(ENABLE_PULSEAUDIO "Enables PulseAudio sound backend" ON)
option(ENABLE_CUBEB "Enables Cubeb sound backend" ON)
option(ENABLE_LLVM "Enables LLVM support, for disassembly" ON)
option(ENABLE_TESTS "Enables building the unit tests" ON)
option(ENABLE_VULKAN "Enables vulkan video backend" ON)
option(USE_DISCORD_PRESENCE "Enables Discord Rich Presence, show the current game on Discord" ON)
option(USE_MGBA "Enables GBA controllers emulation using libmgba" ON)
option(ENABLE_AUTOUPDATE "Enables support for automatic updates" ON)
option(USE_RETRO_ACHIEVEMENTS "Enables integration with retroachievements.org" ON)

# Maintainers: if you consider blanket disabling this for your users, please
# consider the following points:
#  * No data is being sent without explicit user approval (pop up box at first
#    launch).
#  * The Dolphin team relies on the data in order to understand the behavior
#    of our software in the wild.
option(ENABLE_ANALYTICS "Enables opt-in Analytics collection" ON)

option(ENCODE_FRAMEDUMPS "Encode framedumps in AVI format" ON)

option(ENABLE_GPROF "Enable gprof profiling (must be using Debug build)" OFF)
option(FASTLOG "Enable all logs" OFF)
option(OPROFILING "Enable profiling" OFF)

# TODO: Add DSPSpy
option(DSPTOOL "Build dsptool" OFF)

# RetroAchievements developer tools require Windows hooks
if(WIN32)
  option(RC_CLIENT_SUPPORTS_RAINTEGRATION "Enables RetroAchievements developer tools" ON)
endif()

# Enable SDL by default on operating systems that aren't Android.
if(NOT ANDROID)
  option(ENABLE_SDL "Enables SDL as a generic controller backend" ON)
else()
  option(ENABLE_SDL "Enables SDL as a generic controller backend" OFF)
endif()

if(APPLE)
  enable_language(OBJC)
  enable_language(OBJCXX)
  option(MACOS_USE_DEFAULT_SEARCH_PATH "Don't prioritize system library paths" OFF)
  option(SKIP_POSTPROCESS_BUNDLE "Skip postprocessing bundle for redistributability" OFF)
  # Enable adhoc code signing by default (otherwise makefile builds on ARM will not work)
  option(MACOS_CODE_SIGNING "Enable codesigning" ON)
  option(USE_BUNDLED_MOLTENVK "Build MoltenVK from Externals with Dolphin-specific patches" ON)
  set(MACOS_CODE_SIGNING_IDENTITY "-" CACHE STRING "The identity used for codesigning.")
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  option(ENABLE_VTUNE "Enable Intel VTune integration for JIT code." OFF)

  if(NOT ANDROID)
    option(ENABLE_HWDB "Enables the udev hardware database" ON)
    option(ENABLE_EVDEV "Enables the evdev controller backend" ON)
  endif()
endif()

if(UNIX)
  # Builds a relocatable binary on Linux.
  # The Sys folder will need to be copied to the Binaries folder.
  option(LINUX_LOCAL_DEV "Enable relocatable binary" OFF)
endif()

list(APPEND CMAKE_MODULE_PATH
  ${CMAKE_CURRENT_SOURCE_DIR}/CMake
)

# Support functions
include(CheckAndAddFlag)
include(CheckCCompilerFlag)
include(DolphinCompileDefinitions)
include(DolphinDisableWarningsMSVC)
include(DolphinLibraryTools)
include(GNUInstallDirs)
include(RemoveCompileFlag)

# Enable folders for IDE
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Set up paths
set(datadir ${CMAKE_INSTALL_FULL_DATADIR}/dolphin-emu CACHE PATH "datadir")
add_definitions(-DDATA_DIR="${datadir}/")

if(CMAKE_SYSROOT)
  # If we should use a sysroot, tell pkg-config to search for packages in there, not on the host
  set(ENV{PKG_CONFIG_LIBDIR} "${CMAKE_SYSROOT}/usr/lib/pkgconfig:${CMAKE_SYSROOT}/usr/share/pkgconfig")
  set(ENV{PKG_CONFIG_SYSROOT_DIR} "${CMAKE_SYSROOT}")
endif()

# Set where the binary files will be built.  The program will not execute from
# here.  You must run "make install" to install these to the proper location
# as defined above.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/Binaries)

if (WIN32)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/Binary)

  if (CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64|amd64|AMD64")
    string(APPEND CMAKE_RUNTIME_OUTPUT_DIRECTORY /x64)
  elseif (CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
    string(APPEND CMAKE_RUNTIME_OUTPUT_DIRECTORY /ARM64)
  endif()
endif()

# setup CCache
include(CCache)

# Architecture detection and arch specific settings
message(STATUS "Detected architecture: ${CMAKE_SYSTEM_PROCESSOR}")

# Detect 64bit or 32bit
# CMake doesn't provide a simple way to determine 32bit or 64bit
# If we ever support a architecture that is 64bit with 32bit pointers then this'll break
# Of course the chances of that are slim(x32?) so who cares
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(_ARCH_64 1)
  add_definitions(-D_ARCH_64=1)
else()
  set(_ARCH_32 1)
  add_definitions(-D_ARCH_32=1)
endif()

if(ENABLE_GENERIC)
  message(STATUS "Warning! Building generic build!")
  set(_M_GENERIC 1)
  add_definitions(-D_M_GENERIC=1)
elseif(_ARCH_64 AND CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64|amd64|AMD64")
  set(_M_X86_64 1)
  add_definitions(-D_M_X86_64=1)
  check_and_add_flag(HAVE_SSE2 -msse2)
elseif(_ARCH_64 AND CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64|arm64")
  set(_M_ARM_64 1)
  add_definitions(-D_M_ARM_64=1)
  # CRC instruction set is used in the CRC32 hash function
  check_and_add_flag(HAVE_ARCH_ARMV8 -march=armv8-a+crc)
else()
  message(FATAL_ERROR "You're building on an unsupported platform: "
      "'${CMAKE_SYSTEM_PROCESSOR}' with ${CMAKE_SIZEOF_VOID_P}-byte pointers."
      " Enable generic build if you really want a JIT-less binary.")
endif()

if(CMAKE_GENERATOR MATCHES "Ninja")
  check_and_add_flag(DIAGNOSTICS_COLOR -fdiagnostics-color)
elseif(CMAKE_GENERATOR MATCHES "Visual Studio")
  # Only MSBuild needs this, other generators will compile one file at a time
  add_compile_options("/MP")
endif()

if(MSVC)
  check_and_add_flag(EXCEPTIONS /EHsc)
  dolphin_compile_definitions(_DEBUG DEBUG_ONLY)

  # Disable RTTI
  add_compile_options(/GR-)

  # Set warning level 4 (the highest)
  add_compile_options(/W4)

  # Treat all warnings as errors
  add_compile_options(/WX)

  # Disable some warnings
  add_compile_options(
    /wd4201 # nonstandard extension used : nameless struct/union
    /wd4127 # conditional expression is constant
    /wd4100 # 'identifier' : unreferenced formal parameter
    /wd4200 # InputCommon fix temp.
    /wd4244 # 'conversion' conversion from 'type1' to 'type2', possible loss of data
    /wd4121 # 'symbol' : alignment of a member was sensitive to packing
    /wd4324 # Padding was added at the end of a structure because you specified a __declspec(align) value.
    /wd4714 # function 'function' marked as __forceinline not inlined
    /wd4351 # new behavior: elements of array 'array' will be default initialized
    # TODO: Enable this warning once possible
    /wd4245 # conversion from 'type1' to 'type2', signed/unsigned mismatch
    # Currently jits use some annoying code patterns which makes this common
  )

  # Additional warnings
  add_compile_options(
    /w44263 # Non-virtual member function hides base class virtual function
    /w44265 # Class has virtual functions, but destructor is not virtual
    /w44946 # Reinterpret cast between related types
  )

  # All files are encoded as UTF-8
  add_compile_options(/utf-8)

  # Ignore warnings in external headers
  add_compile_options(/external:anglebrackets)
  add_compile_options(/external:W0)
  add_compile_options(/external:templates-)

  # Request deterministic builds
  add_compile_options(/experimental:deterministic)
  add_link_options(/experimental:deterministic)

  # Enable function-level linking
  add_compile_options(/Gy)
  # Generate intrinsic functions
  add_compile_options(/Oi)
  # Enable buffer security check on Debug, disable otherwise
  add_compile_options($<IF:$<CONFIG:Debug>,/GS,/GS->)

=== Source/Core/VideoCommon/CMakeLists.txt ===
add_library(videocommon
  AbstractFramebuffer.cpp
  AbstractFramebuffer.h
  AbstractGfx.cpp
  AbstractGfx.h
  AbstractShader.h
  AbstractStagingTexture.cpp
  AbstractStagingTexture.h
  AbstractTexture.cpp
  AbstractTexture.h
  Assets/CustomAsset.cpp
  Assets/CustomAsset.h
  Assets/CustomAssetLibrary.h
  Assets/CustomAssetLoader.cpp
  Assets/CustomAssetLoader.h
  Assets/CustomResourceManager.cpp
  Assets/CustomResourceManager.h
  Assets/CustomTextureData.cpp
  Assets/CustomTextureData.h
  Assets/DirectFilesystemAssetLibrary.cpp
  Assets/DirectFilesystemAssetLibrary.h
  Assets/MaterialAsset.cpp
  Assets/MaterialAsset.h
  Assets/MeshAsset.cpp
  Assets/MeshAsset.h
  Assets/ShaderAsset.cpp
  Assets/ShaderAsset.h
  Assets/TextureAsset.cpp
  Assets/TextureAsset.h
  Assets/TextureAssetUtils.cpp
  Assets/TextureAssetUtils.h
  Assets/TextureSamplerValue.cpp
  Assets/TextureSamplerValue.h
  Assets/Types.h
  Assets/WatchableFilesystemAssetLibrary.h
  AsyncRequests.cpp
  AsyncRequests.h
  AsyncShaderCompiler.cpp
  AsyncShaderCompiler.h
  BoundingBox.cpp
  BoundingBox.h
  BPFunctions.cpp
  BPFunctions.h
  BPMemory.cpp
  BPMemory.h
  BPStructs.cpp
  BPStructs.h
  CommandProcessor.cpp
  CommandProcessor.h
  ConstantManager.h
  Constants.h
  CPMemory.cpp
  CPMemory.h
  CPUCull.cpp
  CPUCull.h
  CPUCullImpl.h
  DriverDetails.cpp
  DriverDetails.h
  EFBInterface.cpp
  EFBInterface.h
  Fifo.cpp
  Fifo.h
  FramebufferManager.cpp
  FramebufferManager.h
  FramebufferShaderGen.cpp
  FramebufferShaderGen.h
  FrameDumper.cpp
  FrameDumper.h
  FrameDumpFFMpeg.h
  FreeLookCamera.cpp
  FreeLookCamera.h
  GeometryShaderGen.cpp
  GeometryShaderGen.h
  GeometryShaderManager.cpp
  GeometryShaderManager.h
  GraphicsModSystem/Config/GraphicsMod.cpp
  GraphicsModSystem/Config/GraphicsMod.h
  GraphicsModSystem/Config/GraphicsModAsset.cpp
  GraphicsModSystem/Config/GraphicsModAsset.h
  GraphicsModSystem/Config/GraphicsModFeature.cpp
  GraphicsModSystem/Config/GraphicsModFeature.h
  GraphicsModSystem/Config/GraphicsModGroup.cpp
  GraphicsModSystem/Config/GraphicsModGroup.h
  GraphicsModSystem/Config/GraphicsTarget.cpp
  GraphicsModSystem/Config/GraphicsTarget.h
  GraphicsModSystem/Config/GraphicsTargetGroup.cpp
  GraphicsModSystem/Config/GraphicsTargetGroup.h
  GraphicsModSystem/Constants.h
  GraphicsModSystem/Runtime/Actions/CustomPipelineAction.cpp
  GraphicsModSystem/Runtime/Actions/CustomPipelineAction.h
  GraphicsModSystem/Runtime/Actions/MoveAction.cpp
  GraphicsModSystem/Runtime/Actions/MoveAction.h
  GraphicsModSystem/Runtime/Actions/PrintAction.cpp
  GraphicsModSystem/Runtime/Actions/PrintAction.h
  GraphicsModSystem/Runtime/Actions/ScaleAction.cpp
  GraphicsModSystem/Runtime/Actions/ScaleAction.h
  GraphicsModSystem/Runtime/Actions/SkipAction.cpp
  GraphicsModSystem/Runtime/Actions/SkipAction.h
  GraphicsModSystem/Runtime/CustomPipeline.cpp
  GraphicsModSystem/Runtime/CustomPipeline.h
  GraphicsModSystem/Runtime/CustomShaderCache.cpp
  GraphicsModSystem/Runtime/CustomShaderCache.h
  GraphicsModSystem/Runtime/FBInfo.cpp
  GraphicsModSystem/Runtime/FBInfo.h
  GraphicsModSystem/Runtime/GraphicsModAction.h
  GraphicsModSystem/Runtime/GraphicsModActionData.h
  GraphicsModSystem/Runtime/GraphicsModActionFactory.cpp
  GraphicsModSystem/Runtime/GraphicsModActionFactory.h
  GraphicsModSystem/Runtime/GraphicsModManager.cpp
  GraphicsModSystem/Runtime/GraphicsModManager.h
  HiresTextures.cpp
  HiresTextures.h
  IndexGenerator.cpp
  IndexGenerator.h
  LightingShaderGen.cpp
  LightingShaderGen.h
  LookUpTables.h
  NativeVertexFormat.h
  NetPlayChatUI.cpp
  NetPlayChatUI.h
  NetPlayGolfUI.cpp
  NetPlayGolfUI.h
  OnScreenDisplay.cpp
  OnScreenDisplay.h
  OnScreenUI.cpp
  OnScreenUI.h
  OnScreenUIKeyMap.h
  OpcodeDecoding.cpp
  OpcodeDecoding.h
  PerfQueryBase.cpp
  PerfQueryBase.h
  PerformanceMetrics.cpp
  PerformanceMetrics.h
  PerformanceTracker.cpp
  PerformanceTracker.h
  PixelEngine.cpp
  PixelEngine.h
  PixelShaderGen.cpp
  PixelShaderGen.h
  PixelShaderManager.cpp
  PixelShaderManager.h
  PostProcessing.cpp
  PostProcessing.h
  Present.cpp
  Present.h
  RenderState.cpp
  RenderState.h
  ShaderCache.cpp
  ShaderCache.h
  ShaderGenCommon.cpp
  ShaderGenCommon.h
  Spirv.cpp
  Spirv.h
  Statistics.cpp
  Statistics.h
  TextureCacheBase.cpp
  TextureCacheBase.h
  TextureConfig.cpp
  TextureConfig.h
  TextureConversionShader.cpp
  TextureConversionShader.h
  TextureConverterShaderGen.cpp
  TextureConverterShaderGen.h
  TextureDecoder.h
  TextureDecoder_Common.cpp
  TextureDecoder_Util.h
  TextureInfo.cpp
  TextureInfo.h
  TextureUtils.cpp
  TextureUtils.h
  TMEM.cpp
  TMEM.h
  UberShaderCommon.cpp
  UberShaderCommon.h
  UberShaderPixel.cpp
  UberShaderPixel.h
  UberShaderVertex.cpp
  UberShaderVertex.h
  VertexLoader.cpp
  VertexLoader.h
  VertexLoaderBase.cpp
  VertexLoaderBase.h
  VertexLoaderManager.cpp
  VertexLoaderManager.h
  VertexLoaderUtils.h
  VertexLoader_Color.cpp
  VertexLoader_Color.h
  VertexLoader_Normal.cpp
  VertexLoader_Normal.h
  VertexLoader_Position.cpp
  VertexLoader_Position.h
  VertexLoader_TextCoord.cpp
  VertexLoader_TextCoord.h
  VertexManagerBase.cpp
  VertexManagerBase.h
  VertexShaderGen.cpp
  VertexShaderGen.h
  VertexShaderManager.cpp
  VertexShaderManager.h
  VideoBackendBase.cpp
  VideoBackendBase.h
  VideoEvents.h
  VideoCommon.h
  VideoConfig.cpp
  VideoConfig.h
  VideoState.cpp
  VideoState.h
  Widescreen.cpp
  Widescreen.h
  XFMemory.cpp
  XFMemory.h
  XFStateManager.cpp
  XFStateManager.h
  XFStructs.cpp
  XFStructs.h
)

target_link_libraries(videocommon
PUBLIC
  core
PRIVATE
  fmt::fmt
  spng::spng
  xxhash::xxhash
  imgui
  implot
  glslang
  tinygltf
)

if(_M_X86_64)
  target_sources(videocommon PRIVATE
    TextureDecoder_x64.cpp
    VertexLoaderX64.cpp
    VertexLoaderX64.h
  )
elseif(_M_ARM_64)
  target_sources(videocommon PRIVATE
    VertexLoaderARM64.cpp
    VertexLoaderARM64.h
    TextureDecoder_Generic.cpp
  )
else()
  target_sources(videocommon PRIVATE
    TextureDecoder_Generic.cpp
  )
endif()

if(FFmpeg_FOUND)
  target_sources(videocommon PRIVATE
    FrameDumpFFMpeg.cpp
  )
  target_link_libraries(videocommon PRIVATE
    FFmpeg::avcodec
    FFmpeg::avformat
    FFmpeg::avutil
    FFmpeg::swresample
    FFmpeg::swscale
  )
  if(APPLE)
    target_link_libraries(videocommon PRIVATE
      ${COREMEDIA_LIBRARY}
      ${VIDEOTOOLBOX_LIBRARY}
      ${COREVIDEO_LIBRARY}
      ${AUDIOTOOLBOX_LIBRARY}
    )
  endif()
endif()

# Silence warnings on glslang by flagging it as a system include
target_include_directories(videocommon
SYSTEM PUBLIC
  ${CMAKE_SOURCE_DIR}/Externals/glslang/glslang/Public
SYSTEM PRIVATE
  ${CMAKE_SOURCE_DIR}/Externals/glslang/StandAlone
  ${CMAKE_SOURCE_DIR}/Externals/glslang/SPIRV
  ${CMAKE_SOURCE_DIR}/Externals/glslang
)

if(MSVC)
  # Add precompiled header
  target_link_libraries(videocommon PRIVATE use_pch)
endif()

=== Externals/rcheevos/rcheevos/test/Makefile ===
# supported parameters
#  ARCH                  architecture - "x86" or "x64" [detected if not set]
#  BUILD                 use flags for specified upstream consumer - "c89" or "retroarch" [default to "c89"]
#  DEBUG                 if set to anything, builds with DEBUG symbols
#  HAVE_HASH             if set to 0, excludes all hash functionality
#  HAVE_HASH_ROM         if set to 0, excludes rom hash generation
#  HAVE_HASH_DISC        if set to 0, excludes disc hash generation
#  HAVE_HASH_ZIP         if set to 0, excludes zip hash generation
#  HAVE_HASH_ENCRYPTED   if set to 0, excludes encrypted hash generation

RC_SRC=../src
RC_CHEEVOS_SRC=$(RC_SRC)/rcheevos
RC_HASH_SRC=$(RC_SRC)/rhash
RC_API_SRC=$(RC_SRC)/rapi

# default parameter values
ifeq ($(ARCH),)
    UNAME := $(shell uname -s)
    ifeq ($(findstring MINGW64, $(UNAME)), MINGW64)
        ARCH=x64
    else ifeq ($(findstring MINGW32, $(UNAME)), MINGW32)
        ARCH=x86
    else
        $(error Could not determine ARCH)
    endif
endif

ifeq ($(BUILD),)
    BUILD=c89
endif

# OS specific stuff
ifeq ($(OS),Windows_NT)
    EXE=.exe
else ifeq ($(findstring mingw, $(CC)), mingw)
    EXE=.exe
else
    EXE=
endif

# source files
OBJ=$(RC_SRC)/rc_compat.o \
    $(RC_SRC)/rc_client.o \
    $(RC_SRC)/rc_util.o \
    $(RC_SRC)/rc_version.o \
    $(RC_CHEEVOS_SRC)/alloc.o \
    $(RC_CHEEVOS_SRC)/condition.o \
    $(RC_CHEEVOS_SRC)/condset.o \
    $(RC_CHEEVOS_SRC)/consoleinfo.o \
    $(RC_CHEEVOS_SRC)/format.o \
    $(RC_CHEEVOS_SRC)/lboard.o \
    $(RC_CHEEVOS_SRC)/memref.o \
    $(RC_CHEEVOS_SRC)/operand.o \
    $(RC_CHEEVOS_SRC)/rc_validate.o \
    $(RC_CHEEVOS_SRC)/richpresence.o \
    $(RC_CHEEVOS_SRC)/runtime.o \
    $(RC_CHEEVOS_SRC)/runtime_progress.o \
    $(RC_CHEEVOS_SRC)/trigger.o \
    $(RC_CHEEVOS_SRC)/value.o \
    $(RC_HASH_SRC)/md5.o \
    $(RC_API_SRC)/rc_api_common.o \
    $(RC_API_SRC)/rc_api_editor.o \
    $(RC_API_SRC)/rc_api_info.o \
    $(RC_API_SRC)/rc_api_runtime.o \
    $(RC_API_SRC)/rc_api_user.o \
    rcheevos/test_condition.o \
    rcheevos/test_condset.o \
    rcheevos/test_consoleinfo.o \
    rcheevos/test_format.o \
    rcheevos/test_lboard.o \
    rcheevos/test_memref.o \
    rcheevos/test_operand.o \
    rcheevos/test_rc_validate.o \
    rcheevos/test_richpresence.o \
    rcheevos/test_runtime.o \
    rcheevos/test_runtime_progress.o \
    rcheevos/test_timing.o \
    rcheevos/test_trigger.o \
    rcheevos/test_value.o \
    rapi/test_rc_api_common.o \
    rapi/test_rc_api_editor.o \
    rapi/test_rc_api_info.o \
    rapi/test_rc_api_runtime.o \
    rapi/test_rc_api_user.o \
    test_rc_client.o \
    test.o

# compile flags
CFLAGS=-Wall -Werror -Wno-long-long -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
INCLUDES=-I../include -I$(RC_CHEEVOS_SRC) -I.

ifeq ($(ARCH), x86)
    CFLAGS += -m32
    LDFLAGS += -m32
else ifeq ($(ARCH), x64)
    CFLAGS += -m64
    LDFLAGS += -m64
else
    $(error unknown ARCH "$(ARCH)")
endif

EXTRA=
ifdef DEBUG
    CFLAGS += -O0 -g
    EXTRA +=  DEBUG
else
    CFLAGS += -O3
endif

# more strict validation for source files to eliminate warnings/errors in upstream consumers
# -Wextra includes -Wsign-compare -Wtype-limits -Wimplicit-fallthrough=3 -Wunused-parameter and more
# -pedantic issues errors when using GNU extensions or other things that are not strictly ISO C
SRC_CFLAGS=-Wextra -Wshadow -pedantic
# 3DS build (retroarch) doesn't support signed char
SRC_CFLAGS += -fno-signed-char

ifeq ($(BUILD), c89)
    CFLAGS += -std=c89
else ifeq ($(BUILD), c99)
    CFLAGS += -std=c99
else ifeq ($(BUILD), retroarch)
    # RetroArch builds with gcc8 and gnu99 which adds some extra warning validations
    SRC_CFLAGS += -std=gnu99 -D_GNU_SOURCE -Wall -Warray-bounds=2 -Wincompatible-pointer-types
    # Also include the RC_CLIENT_SUPPORTS_EXTERNAL flag to ensure we do the full level of validation on the
    # most code. The c89 build will ensure things still build without the RC_CLIENT_SUPPORTS_EXTERNAL flag.
    CFLAGS += -DRC_CLIENT_SUPPORTS_EXTERNAL
    OBJ += $(RC_SRC)/rc_client_external.o test_rc_client_external.o
else
    $(error unknown BUILD "$(BUILD)")
endif

# support for building without hash subdirectory
ifeq ($(HAVE_HASH), 0)
    EXTRA += |NO_HASH
else
    CFLAGS += -DRC_CLIENT_SUPPORTS_HASH
    OBJ += $(RC_HASH_SRC)/hash.o \
           $(RC_SRC)/rc_libretro.o \
           rhash/data.o \
           rhash/mock_filereader.o \
           rhash/test_hash.o \
           test_rc_libretro.o

    ifeq ($(HAVE_HASH_ROM), 0)
        EXTRA += |NO_HASH_ROM
        CFLAGS += -DRC_HASH_NO_ROM
    else
        OBJ += $(RC_HASH_SRC)/hash_rom.o \
               rhash/test_hash_rom.o
    endif

    ifeq ($(HAVE_HASH_DISC), 0)
        EXTRA += |NO_HASH_DISC
        CFLAGS += -DRC_HASH_NO_DISC
    else
        OBJ += $(RC_HASH_SRC)/cdreader.o \
               $(RC_HASH_SRC)/hash_disc.o \
               rhash/test_cdreader.o \
               rhash/test_hash_disc.o
    endif

    ifeq ($(HAVE_HASH_ZIP), 0)
        EXTRA += |NO_HASH_ZIP
        CFLAGS += -DRC_HASH_NO_ZIP
    else
        OBJ += $(RC_HASH_SRC)/hash_zip.o \
               rhash/test_hash_zip.o
    endif

    ifeq ($(HAVE_HASH_ENCRYPTED), 0)
        EXTRA += |NO_HASH_ENCRYPTED
        CFLAGS += -DRC_HASH_NO_ENCRYPTED
    else
        OBJ += $(RC_HASH_SRC)/hash_encrypted.o \
               $(RC_HASH_SRC)/aes.o
    endif
endif

# recipes
$(info ==== rcheevos test [$(BUILD)/$(ARCH)$(EXTRA)] ====)

all: test

$(RC_SRC)/%.o: $(RC_SRC)/%.c
	$(CC) $(CFLAGS) $(SRC_CFLAGS) $(INCLUDES) -c $< -o $@

$(RC_CHEEVOS_SRC)/%.o: $(RC_CHEEVOS_SRC)/%.c
	$(CC) $(CFLAGS) $(SRC_CFLAGS) $(INCLUDES) -c $< -o $@

$(RC_HASH_SRC)/%.o: $(RC_HASH_SRC)/%.c
	$(CC) $(CFLAGS) $(SRC_CFLAGS) $(INCLUDES) -c $< -o $@

$(RC_API_SRC)/%.o: $(RC_API_SRC)/%.c
	$(CC) $(CFLAGS) $(SRC_CFLAGS) $(INCLUDES) -c $< -o $@

%.o: %.c
	$(CC) $(CFLAGS) $(INCLUDES) -c $< -o $@

test: $(OBJ)
	$(CC) $(LDFLAGS) -o $@$(EXE) $+ -lm
	@echo ---------------------------------

check_ctype:
	@if grep -rnI "isalpha([^(u]" ../src/*; \
	then echo "*** Error: isalpha without unsigned char cast" && false; \
	fi
	@if grep -rnI "isalnum([^(u]" ../src/*; \
	then echo "*** Error: isalnum without unsigned char cast" && false; \
	fi
	@if grep -rnI "isdigit([^(u]" ../src/*; \
	then echo "*** Error: isdigit without unsigned char cast" && false; \
	fi
	@if grep -rnI "isspace([^(u]" ../src/*; \
	then echo "*** Error: isspace without unsigned char cast" && false; \
	fi

runtests: test
	@./test$(EXE)

valgrind: test
	@valgrind --leak-check=full --error-exitcode=1 ./test$(EXE)

clean:
	rm -f test$(EXE) $(OBJ)

=== Source/Core/VideoBackends/D3D12/CMakeLists.txt ===
add_library(videod3d12
  D3D12BoundingBox.cpp
  D3D12BoundingBox.h
  D3D12PerfQuery.cpp
  D3D12PerfQuery.h
  D3D12Gfx.cpp
  D3D12Gfx.h
  D3D12StreamBuffer.cpp
  D3D12StreamBuffer.h
  D3D12SwapChain.cpp
  D3D12SwapChain.h
  D3D12VertexManager.cpp
  D3D12VertexManager.h
  DescriptorAllocator.cpp
  DescriptorAllocator.h
  DescriptorHeapManager.cpp
  DescriptorHeapManager.h
  DX12Context.cpp
  DX12Context.h
  DX12Pipeline.cpp
  DX12Pipeline.h
  DX12Shader.cpp
  DX12Shader.h
  DX12Texture.cpp
  DX12Texture.h
  DX12VertexFormat.cpp
  DX12VertexFormat.h
  VideoBackend.cpp
  VideoBackend.h
)

target_link_libraries(videod3d12
PUBLIC
  common
  videocommon
  videod3dcommon
)

if(MSVC)
  # Add precompiled header
  target_link_libraries(videod3d12 PRIVATE use_pch)
endif()

=== debian/control ===
Source: dolphin-emu
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Brandon Barnes <winterknight@email.com>,
 James Cowgill <jcowgill@debian.org>,
 Jordi Mallach <jordi@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 gettext,
#glslang-dev,
 libao-dev,
 libasound2-dev,
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libbluetooth-dev,
 libbz2-dev,
 libcubeb-dev,
 libcurl4-openssl-dev,
 libegl-dev,
 libenet-dev (>= 1.3.18),
 libevdev-dev,
 libfmt-dev (>= 10.1),
 libgl-dev,
 libgtest-dev,
 libhidapi-dev,
 libimgui-dev,
 liblz4-dev,
 liblzo2-dev,
 liblzma-dev,
 libminiupnpc-dev (>= 1.7),
 libmgba-dev (>= 0.10.0),
 libopenal-dev,
 libpulse-dev,
 libpugixml-dev,
 libsdl3-dev,
 libsfml-dev (>= 3.0),
 libsoil-dev,
 libspng-dev,
 libswscale-dev,
 libsystemd-dev,
 libtinygltf-dev,
 libvulkan-dev,
 libvulkan-memory-allocator-dev,
 libx11-dev,
 libxi-dev (>= 2:1.5),
 libxrandr-dev,
 libxxhash-dev,
 libudev-dev,
 libusb-1.0-0-dev,
 libzstd-dev,
 lsb-release,
 pkgconf,
 portaudio19-dev,
 qt6-base-private-dev,
 qt6-svg-dev,
 zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://dolphin-emu.org/
Vcs-Git: https://salsa.debian.org/games-team/dolphin-emu.git
Vcs-Browser: https://salsa.debian.org/games-team/dolphin-emu

Package: dolphin-emu
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}, dolphin-emu-data (= ${source:Version})
Description: Gamecube and Wii emulator
 Dolphin is an emulator for two recent Nintendo video game consoles: the
 GameCube and the Wii. It allows PC gamers to enjoy games for these two
 consoles in full HD (1080p) with several enhancements: compatibility with all
 PC controllers, turbo speed, networked multiplayer, and even more.

Package: dolphin-emu-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: dolphin-emu
Description: Gamecube and Wii emulator - data files
 Dolphin is an emulator for two recent Nintendo video game consoles: the
 GameCube and the Wii. It allows PC gamers to enjoy games for these two
 consoles in full HD (1080p) with several enhancements: compatibility with all
 PC controllers, turbo speed, networked multiplayer, and even more.
 .
 This package contains the platform independent data files for Dolphin.
